#!/usr/bin/python
# DH5HS

import sys
import serial
import os
import msvcrt
import time

localtime = time.localtime(time.time())

print ("---V1.0------------------------------------------------------")
print ("IC7300 PC Zeitsynchronisation >>> 2019 von DH5HS@darc.de <<<<")
print ("-------------------------------------------------------------")


if len(sys.argv) != 3:
	print ("Ooops! Bitte den Comport und Baudrate angeben, z.B. COM4 4800")
	sys.exit(0)


comport = sys.argv[1]
print ("Comport  :" + comport)

baudrate = sys.argv[2]
br = int(baudrate)
print ("Baudrate :" + str(br))

try:
	ser = serial.Serial(comport, br, timeout = 3) 
except:
	print("Ooops! Konnte serielle Schnittstelle nicht öffnen.")
	sys.exit(1)


time.sleep(1)

print ("\nDatum des IC7300 wird mit dem PC synchronisiert!")
s=(b'\xfe\xfe\x94\x00\x1A\x05\x00\x94\x20')
ser.write (s)

yr = localtime.tm_year
yr=yr-2000
yr = int(str(yr),16)

mon= localtime.tm_mon
mon = int(str(mon),16)
day= localtime.tm_mday
day = int(str(day),16)

dList = [yr,mon,day]
data=bytes(dList)
ser.write (data)
s = (b'\xfd')
ser.write (s)

s = ""
while s != (b'\xfd') :
	s = ser.read()
	print (s, end=" ")
	if msvcrt.kbhit():
		break

print ("\n\nUhrzeit des IC7300 wird mit dem PC synchronisiert!")
time.sleep(1)
ser.write (b'\xfe\xfe\x94\x00\x1A\x05\x00\x95')
hour= localtime.tm_hour
hour = int(str(hour),16)
minu= localtime.tm_min
minu = int(str(minu),16)

dList = [hour,minu]
data=bytes(dList)
ser.write (data)
s = (b'\xfd')
ser.write (s)

s = ""
while s != (b'\xfd') :
	s = ser.read()
	print (s, end=" ")
	if msvcrt.kbhit():
		break

ser.close()
